# Changelog

All notable changes to DUKE Agents will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [1.0.0] - 2024-01-03

### Added
- Initial release of DUKE Agents framework
- IPO (Input-Process-Output) architecture implementation
- AtomicAgent for simple task execution
- CodeActAgent for code generation and execution
- Mistral AI integration (Mistral and Codestral models)
- Workflow memory management with feedback loops
- Auto-correction mechanism with satisfaction scoring
- Linear and LLM-driven workflow orchestration
- Full type safety with Pydantic models
- Comprehensive configuration management
- Example implementations and documentation

### Security
- Sandboxed code execution environment
- API key validation and secure handling

### Documentation
- Complete API documentation
- Getting started guide
- Example usage scenarios
- Configuration guide